#include <stdlib.h>
#include <stdio.h>
#include "realfftf.h"

fft_type *data;

double d1,d2;


void main(int argc,char *argv[])
{
   int points,i;
   FILE *fp1,*fp2;
   char filename[20];

   if(argc>1)
      fp1=fopen(argv[1],"r");
   else
   {
      printf("Input file name: ");
      scanf("%s",filename);
      fp1=fopen(filename,"r");
   }

   if(!fp1)
   {
      puts("Error opening input file!");
      exit(1);
   }

   if(argc>2)
      fp2=fopen(argv[2],"w");
   else
   {
      printf("Output file name: ");
      scanf("%s",filename);
      fp2=fopen(filename,"w");
   }

   if(!fp2)
   {
      puts("Error opening output file!");
      exit(1);
   }

   if(argc>3)
      points=atoi(argv[3]);
   else
   {
      printf("Number of points: ");
      scanf("%d",&points);
   }

   data=(fft_type *)malloc(points*sizeof(fft_type));

   for(i=0;i<points;i++)
   {
      fscanf(fp1,"%lf",&d1);
      data[i]=d1;
   }

   fclose(fp1);

   InitializeFFT(points);

   RealFFT(data);

   for(i=0;i<(points/2);i++)
   {
      d1=data[BitReversed[i]];
      d2=data[BitReversed[i]+1];
      fprintf(fp2,"%.20lg  %.20lg\n",d1,d2);
   }

   /*
    *  For magnitude/phase output, do the following:
   {
      double re=data[BitReversed[i]];
      double im=data[BitReversed[i]+1];

      fprintf(fp2,"%lf  %lf\n",sqrt(re*re+im*im),atan2(im,re));
   }
    */

   fclose(fp2);
   /* Free up the FFT buffers */
   EndFFT();
}
